git-submodule.shon commit Sync with 1.7.3.4 (15368e1)
   1#!/bin/sh
   2#
   3# git-submodules.sh: add, init, update or list git submodules
   4#
   5# Copyright (c) 2007 Lars Hjemli
   6
   7dashless=$(basename "$0" | sed -e 's/-/ /')
   8USAGE="[--quiet] add [-b branch] [-f|--force] [--reference <repository>] [--] <repository> [<path>]
   9   or: $dashless [--quiet] status [--cached] [--recursive] [--] [<path>...]
  10   or: $dashless [--quiet] init [--] [<path>...]
  11   or: $dashless [--quiet] update [--init] [-N|--no-fetch] [--rebase] [--reference <repository>] [--merge] [--recursive] [--] [<path>...]
  12   or: $dashless [--quiet] summary [--cached|--files] [--summary-limit <n>] [commit] [--] [<path>...]
  13   or: $dashless [--quiet] foreach [--recursive] <command>
  14   or: $dashless [--quiet] sync [--] [<path>...]"
  15OPTIONS_SPEC=
  16. git-sh-setup
  17. git-parse-remote
  18require_work_tree
  19
  20command=
  21branch=
  22force=
  23reference=
  24cached=
  25recursive=
  26init=
  27files=
  28nofetch=
  29update=
  30prefix=
  31
  32# Resolve relative url by appending to parent's url
  33resolve_relative_url ()
  34{
  35        remote=$(get_default_remote)
  36        remoteurl=$(git config "remote.$remote.url") ||
  37                die "remote ($remote) does not have a url defined in .git/config"
  38        url="$1"
  39        remoteurl=${remoteurl%/}
  40        while test -n "$url"
  41        do
  42                case "$url" in
  43                ../*)
  44                        url="${url#../}"
  45                        remoteurl="${remoteurl%/*}"
  46                        ;;
  47                ./*)
  48                        url="${url#./}"
  49                        ;;
  50                *)
  51                        break;;
  52                esac
  53        done
  54        echo "$remoteurl/${url%/}"
  55}
  56
  57#
  58# Get submodule info for registered submodules
  59# $@ = path to limit submodule list
  60#
  61module_list()
  62{
  63        git ls-files --error-unmatch --stage -- "$@" | sane_grep '^160000 '
  64}
  65
  66#
  67# Map submodule path to submodule name
  68#
  69# $1 = path
  70#
  71module_name()
  72{
  73        # Do we have "submodule.<something>.path = $1" defined in .gitmodules file?
  74        re=$(printf '%s\n' "$1" | sed -e 's/[].[^$\\*]/\\&/g')
  75        name=$( git config -f .gitmodules --get-regexp '^submodule\..*\.path$' |
  76                sed -n -e 's|^submodule\.\(.*\)\.path '"$re"'$|\1|p' )
  77       test -z "$name" &&
  78       die "No submodule mapping found in .gitmodules for path '$path'"
  79       echo "$name"
  80}
  81
  82#
  83# Clone a submodule
  84#
  85# Prior to calling, cmd_update checks that a possibly existing
  86# path is not a git repository.
  87# Likewise, cmd_add checks that path does not exist at all,
  88# since it is the location of a new submodule.
  89#
  90module_clone()
  91{
  92        path=$1
  93        url=$2
  94        reference="$3"
  95
  96        # If there already is a directory at the submodule path,
  97        # expect it to be empty (since that is the default checkout
  98        # action) and try to remove it.
  99        # Note: if $path is a symlink to a directory the test will
 100        # succeed but the rmdir will fail. We might want to fix this.
 101        if test -d "$path"
 102        then
 103                rmdir "$path" 2>/dev/null ||
 104                die "Directory '$path' exists, but is neither empty nor a git repository"
 105        fi
 106
 107        test -e "$path" &&
 108        die "A file already exist at path '$path'"
 109
 110        if test -n "$reference"
 111        then
 112                git-clone "$reference" -n "$url" "$path"
 113        else
 114                git-clone -n "$url" "$path"
 115        fi ||
 116        die "Clone of '$url' into submodule path '$path' failed"
 117}
 118
 119#
 120# Add a new submodule to the working tree, .gitmodules and the index
 121#
 122# $@ = repo path
 123#
 124# optional branch is stored in global branch variable
 125#
 126cmd_add()
 127{
 128        # parse $args after "submodule ... add".
 129        while test $# -ne 0
 130        do
 131                case "$1" in
 132                -b | --branch)
 133                        case "$2" in '') usage ;; esac
 134                        branch=$2
 135                        shift
 136                        ;;
 137                -f | --force)
 138                        force=$1
 139                        ;;
 140                -q|--quiet)
 141                        GIT_QUIET=1
 142                        ;;
 143                --reference)
 144                        case "$2" in '') usage ;; esac
 145                        reference="--reference=$2"
 146                        shift
 147                        ;;
 148                --reference=*)
 149                        reference="$1"
 150                        shift
 151                        ;;
 152                --)
 153                        shift
 154                        break
 155                        ;;
 156                -*)
 157                        usage
 158                        ;;
 159                *)
 160                        break
 161                        ;;
 162                esac
 163                shift
 164        done
 165
 166        repo=$1
 167        path=$2
 168
 169        if test -z "$path"; then
 170                path=$(echo "$repo" |
 171                        sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
 172        fi
 173
 174        if test -z "$repo" -o -z "$path"; then
 175                usage
 176        fi
 177
 178        # assure repo is absolute or relative to parent
 179        case "$repo" in
 180        ./*|../*)
 181                # dereference source url relative to parent's url
 182                realrepo=$(resolve_relative_url "$repo") || exit
 183                ;;
 184        *:*|/*)
 185                # absolute url
 186                realrepo=$repo
 187                ;;
 188        *)
 189                die "repo URL: '$repo' must be absolute or begin with ./|../"
 190        ;;
 191        esac
 192
 193        # normalize path:
 194        # multiple //; leading ./; /./; /../; trailing /
 195        path=$(printf '%s/\n' "$path" |
 196                sed -e '
 197                        s|//*|/|g
 198                        s|^\(\./\)*||
 199                        s|/\./|/|g
 200                        :start
 201                        s|\([^/]*\)/\.\./||
 202                        tstart
 203                        s|/*$||
 204                ')
 205        git ls-files --error-unmatch "$path" > /dev/null 2>&1 &&
 206        die "'$path' already exists in the index"
 207
 208        if test -z "$force" && ! git add --dry-run --ignore-missing "$path" > /dev/null 2>&1
 209        then
 210                echo >&2 "The following path is ignored by one of your .gitignore files:" &&
 211                echo >&2 $path &&
 212                echo >&2 "Use -f if you really want to add it."
 213                exit 1
 214        fi
 215
 216        # perhaps the path exists and is already a git repo, else clone it
 217        if test -e "$path"
 218        then
 219                if test -d "$path"/.git -o -f "$path"/.git
 220                then
 221                        echo "Adding existing repo at '$path' to the index"
 222                else
 223                        die "'$path' already exists and is not a valid git repo"
 224                fi
 225
 226                case "$repo" in
 227                ./*|../*)
 228                        url=$(resolve_relative_url "$repo") || exit
 229                    ;;
 230                *)
 231                        url="$repo"
 232                        ;;
 233                esac
 234                git config submodule."$path".url "$url"
 235        else
 236
 237                module_clone "$path" "$realrepo" "$reference" || exit
 238                (
 239                        clear_local_git_env
 240                        cd "$path" &&
 241                        # ash fails to wordsplit ${branch:+-b "$branch"...}
 242                        case "$branch" in
 243                        '') git checkout -f -q ;;
 244                        ?*) git checkout -f -q -b "$branch" "origin/$branch" ;;
 245                        esac
 246                ) || die "Unable to checkout submodule '$path'"
 247        fi
 248
 249        git add $force "$path" ||
 250        die "Failed to add submodule '$path'"
 251
 252        git config -f .gitmodules submodule."$path".path "$path" &&
 253        git config -f .gitmodules submodule."$path".url "$repo" &&
 254        git add --force .gitmodules ||
 255        die "Failed to register submodule '$path'"
 256}
 257
 258#
 259# Execute an arbitrary command sequence in each checked out
 260# submodule
 261#
 262# $@ = command to execute
 263#
 264cmd_foreach()
 265{
 266        # parse $args after "submodule ... foreach".
 267        while test $# -ne 0
 268        do
 269                case "$1" in
 270                -q|--quiet)
 271                        GIT_QUIET=1
 272                        ;;
 273                --recursive)
 274                        recursive=1
 275                        ;;
 276                -*)
 277                        usage
 278                        ;;
 279                *)
 280                        break
 281                        ;;
 282                esac
 283                shift
 284        done
 285
 286        toplevel=$(pwd)
 287
 288        module_list |
 289        while read mode sha1 stage path
 290        do
 291                if test -e "$path"/.git
 292                then
 293                        say "Entering '$prefix$path'"
 294                        name=$(module_name "$path")
 295                        (
 296                                prefix="$prefix$path/"
 297                                clear_local_git_env
 298                                cd "$path" &&
 299                                eval "$@" &&
 300                                if test -n "$recursive"
 301                                then
 302                                        cmd_foreach "--recursive" "$@"
 303                                fi
 304                        ) ||
 305                        die "Stopping at '$path'; script returned non-zero status."
 306                fi
 307        done
 308}
 309
 310#
 311# Register submodules in .git/config
 312#
 313# $@ = requested paths (default to all)
 314#
 315cmd_init()
 316{
 317        # parse $args after "submodule ... init".
 318        while test $# -ne 0
 319        do
 320                case "$1" in
 321                -q|--quiet)
 322                        GIT_QUIET=1
 323                        ;;
 324                --)
 325                        shift
 326                        break
 327                        ;;
 328                -*)
 329                        usage
 330                        ;;
 331                *)
 332                        break
 333                        ;;
 334                esac
 335                shift
 336        done
 337
 338        module_list "$@" |
 339        while read mode sha1 stage path
 340        do
 341                # Skip already registered paths
 342                name=$(module_name "$path") || exit
 343                url=$(git config submodule."$name".url)
 344                test -z "$url" || continue
 345
 346                url=$(git config -f .gitmodules submodule."$name".url)
 347                test -z "$url" &&
 348                die "No url found for submodule path '$path' in .gitmodules"
 349
 350                # Possibly a url relative to parent
 351                case "$url" in
 352                ./*|../*)
 353                        url=$(resolve_relative_url "$url") || exit
 354                        ;;
 355                esac
 356
 357                git config submodule."$name".url "$url" ||
 358                die "Failed to register url for submodule path '$path'"
 359
 360                upd="$(git config -f .gitmodules submodule."$name".update)"
 361                test -z "$upd" ||
 362                git config submodule."$name".update "$upd" ||
 363                die "Failed to register update mode for submodule path '$path'"
 364
 365                say "Submodule '$name' ($url) registered for path '$path'"
 366        done
 367}
 368
 369#
 370# Update each submodule path to correct revision, using clone and checkout as needed
 371#
 372# $@ = requested paths (default to all)
 373#
 374cmd_update()
 375{
 376        # parse $args after "submodule ... update".
 377        orig_flags=
 378        while test $# -ne 0
 379        do
 380                case "$1" in
 381                -q|--quiet)
 382                        GIT_QUIET=1
 383                        ;;
 384                -i|--init)
 385                        init=1
 386                        ;;
 387                -N|--no-fetch)
 388                        nofetch=1
 389                        ;;
 390                -r|--rebase)
 391                        update="rebase"
 392                        ;;
 393                --reference)
 394                        case "$2" in '') usage ;; esac
 395                        reference="--reference=$2"
 396                        orig_flags="$orig_flags $(git rev-parse --sq-quote "$1")"
 397                        shift
 398                        ;;
 399                --reference=*)
 400                        reference="$1"
 401                        ;;
 402                -m|--merge)
 403                        update="merge"
 404                        ;;
 405                --recursive)
 406                        recursive=1
 407                        ;;
 408                --)
 409                        shift
 410                        break
 411                        ;;
 412                -*)
 413                        usage
 414                        ;;
 415                *)
 416                        break
 417                        ;;
 418                esac
 419                orig_flags="$orig_flags $(git rev-parse --sq-quote "$1")"
 420                shift
 421        done
 422
 423        if test -n "$init"
 424        then
 425                cmd_init "--" "$@" || return
 426        fi
 427
 428        module_list "$@" |
 429        while read mode sha1 stage path
 430        do
 431                name=$(module_name "$path") || exit
 432                url=$(git config submodule."$name".url)
 433                update_module=$(git config submodule."$name".update)
 434                if test -z "$url"
 435                then
 436                        # Only mention uninitialized submodules when its
 437                        # path have been specified
 438                        test "$#" != "0" &&
 439                        say "Submodule path '$path' not initialized" &&
 440                        say "Maybe you want to use 'update --init'?"
 441                        continue
 442                fi
 443
 444                if ! test -d "$path"/.git -o -f "$path"/.git
 445                then
 446                        module_clone "$path" "$url" "$reference"|| exit
 447                        subsha1=
 448                else
 449                        subsha1=$(clear_local_git_env; cd "$path" &&
 450                                git rev-parse --verify HEAD) ||
 451                        die "Unable to find current revision in submodule path '$path'"
 452                fi
 453
 454                if ! test -z "$update"
 455                then
 456                        update_module=$update
 457                fi
 458
 459                if test "$subsha1" != "$sha1"
 460                then
 461                        force=
 462                        if test -z "$subsha1"
 463                        then
 464                                force="-f"
 465                        fi
 466
 467                        if test -z "$nofetch"
 468                        then
 469                                (clear_local_git_env; cd "$path" &&
 470                                        git-fetch) ||
 471                                die "Unable to fetch in submodule path '$path'"
 472                        fi
 473
 474                        case "$update_module" in
 475                        rebase)
 476                                command="git rebase"
 477                                action="rebase"
 478                                msg="rebased onto"
 479                                ;;
 480                        merge)
 481                                command="git merge"
 482                                action="merge"
 483                                msg="merged in"
 484                                ;;
 485                        *)
 486                                command="git checkout $force -q"
 487                                action="checkout"
 488                                msg="checked out"
 489                                ;;
 490                        esac
 491
 492                        (clear_local_git_env; cd "$path" && $command "$sha1") ||
 493                        die "Unable to $action '$sha1' in submodule path '$path'"
 494                        say "Submodule path '$path': $msg '$sha1'"
 495                fi
 496
 497                if test -n "$recursive"
 498                then
 499                        (clear_local_git_env; cd "$path" && eval cmd_update "$orig_flags") ||
 500                        die "Failed to recurse into submodule path '$path'"
 501                fi
 502        done
 503}
 504
 505set_name_rev () {
 506        revname=$( (
 507                clear_local_git_env
 508                cd "$1" && {
 509                        git describe "$2" 2>/dev/null ||
 510                        git describe --tags "$2" 2>/dev/null ||
 511                        git describe --contains "$2" 2>/dev/null ||
 512                        git describe --all --always "$2"
 513                }
 514        ) )
 515        test -z "$revname" || revname=" ($revname)"
 516}
 517#
 518# Show commit summary for submodules in index or working tree
 519#
 520# If '--cached' is given, show summary between index and given commit,
 521# or between working tree and given commit
 522#
 523# $@ = [commit (default 'HEAD'),] requested paths (default all)
 524#
 525cmd_summary() {
 526        summary_limit=-1
 527        for_status=
 528        diff_cmd=diff-index
 529
 530        # parse $args after "submodule ... summary".
 531        while test $# -ne 0
 532        do
 533                case "$1" in
 534                --cached)
 535                        cached="$1"
 536                        ;;
 537                --files)
 538                        files="$1"
 539                        ;;
 540                --for-status)
 541                        for_status="$1"
 542                        ;;
 543                -n|--summary-limit)
 544                        if summary_limit=$(($2 + 0)) 2>/dev/null && test "$summary_limit" = "$2"
 545                        then
 546                                :
 547                        else
 548                                usage
 549                        fi
 550                        shift
 551                        ;;
 552                --)
 553                        shift
 554                        break
 555                        ;;
 556                -*)
 557                        usage
 558                        ;;
 559                *)
 560                        break
 561                        ;;
 562                esac
 563                shift
 564        done
 565
 566        test $summary_limit = 0 && return
 567
 568        if rev=$(git rev-parse -q --verify --default HEAD ${1+"$1"})
 569        then
 570                head=$rev
 571                test $# = 0 || shift
 572        elif test -z "$1" -o "$1" = "HEAD"
 573        then
 574                # before the first commit: compare with an empty tree
 575                head=$(git hash-object -w -t tree --stdin </dev/null)
 576                test -z "$1" || shift
 577        else
 578                head="HEAD"
 579        fi
 580
 581        if [ -n "$files" ]
 582        then
 583                test -n "$cached" &&
 584                die "--cached cannot be used with --files"
 585                diff_cmd=diff-files
 586                head=
 587        fi
 588
 589        cd_to_toplevel
 590        # Get modified modules cared by user
 591        modules=$(git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- "$@" |
 592                sane_egrep '^:([0-7]* )?160000' |
 593                while read mod_src mod_dst sha1_src sha1_dst status name
 594                do
 595                        # Always show modules deleted or type-changed (blob<->module)
 596                        test $status = D -o $status = T && echo "$name" && continue
 597                        # Also show added or modified modules which are checked out
 598                        GIT_DIR="$name/.git" git-rev-parse --git-dir >/dev/null 2>&1 &&
 599                        echo "$name"
 600                done
 601        )
 602
 603        test -z "$modules" && return
 604
 605        git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- $modules |
 606        sane_egrep '^:([0-7]* )?160000' |
 607        cut -c2- |
 608        while read mod_src mod_dst sha1_src sha1_dst status name
 609        do
 610                if test -z "$cached" &&
 611                        test $sha1_dst = 0000000000000000000000000000000000000000
 612                then
 613                        case "$mod_dst" in
 614                        160000)
 615                                sha1_dst=$(GIT_DIR="$name/.git" git rev-parse HEAD)
 616                                ;;
 617                        100644 | 100755 | 120000)
 618                                sha1_dst=$(git hash-object $name)
 619                                ;;
 620                        000000)
 621                                ;; # removed
 622                        *)
 623                                # unexpected type
 624                                echo >&2 "unexpected mode $mod_dst"
 625                                continue ;;
 626                        esac
 627                fi
 628                missing_src=
 629                missing_dst=
 630
 631                test $mod_src = 160000 &&
 632                ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_src^0 >/dev/null &&
 633                missing_src=t
 634
 635                test $mod_dst = 160000 &&
 636                ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_dst^0 >/dev/null &&
 637                missing_dst=t
 638
 639                total_commits=
 640                case "$missing_src,$missing_dst" in
 641                t,)
 642                        errmsg="  Warn: $name doesn't contain commit $sha1_src"
 643                        ;;
 644                ,t)
 645                        errmsg="  Warn: $name doesn't contain commit $sha1_dst"
 646                        ;;
 647                t,t)
 648                        errmsg="  Warn: $name doesn't contain commits $sha1_src and $sha1_dst"
 649                        ;;
 650                *)
 651                        errmsg=
 652                        total_commits=$(
 653                        if test $mod_src = 160000 -a $mod_dst = 160000
 654                        then
 655                                range="$sha1_src...$sha1_dst"
 656                        elif test $mod_src = 160000
 657                        then
 658                                range=$sha1_src
 659                        else
 660                                range=$sha1_dst
 661                        fi
 662                        GIT_DIR="$name/.git" \
 663                        git rev-list --first-parent $range -- | wc -l
 664                        )
 665                        total_commits=" ($(($total_commits + 0)))"
 666                        ;;
 667                esac
 668
 669                sha1_abbr_src=$(echo $sha1_src | cut -c1-7)
 670                sha1_abbr_dst=$(echo $sha1_dst | cut -c1-7)
 671                if test $status = T
 672                then
 673                        if test $mod_dst = 160000
 674                        then
 675                                echo "* $name $sha1_abbr_src(blob)->$sha1_abbr_dst(submodule)$total_commits:"
 676                        else
 677                                echo "* $name $sha1_abbr_src(submodule)->$sha1_abbr_dst(blob)$total_commits:"
 678                        fi
 679                else
 680                        echo "* $name $sha1_abbr_src...$sha1_abbr_dst$total_commits:"
 681                fi
 682                if test -n "$errmsg"
 683                then
 684                        # Don't give error msg for modification whose dst is not submodule
 685                        # i.e. deleted or changed to blob
 686                        test $mod_dst = 160000 && echo "$errmsg"
 687                else
 688                        if test $mod_src = 160000 -a $mod_dst = 160000
 689                        then
 690                                limit=
 691                                test $summary_limit -gt 0 && limit="-$summary_limit"
 692                                GIT_DIR="$name/.git" \
 693                                git log $limit --pretty='format:  %m %s' \
 694                                --first-parent $sha1_src...$sha1_dst
 695                        elif test $mod_dst = 160000
 696                        then
 697                                GIT_DIR="$name/.git" \
 698                                git log --pretty='format:  > %s' -1 $sha1_dst
 699                        else
 700                                GIT_DIR="$name/.git" \
 701                                git log --pretty='format:  < %s' -1 $sha1_src
 702                        fi
 703                        echo
 704                fi
 705                echo
 706        done |
 707        if test -n "$for_status"; then
 708                if [ -n "$files" ]; then
 709                        echo "# Submodules changed but not updated:"
 710                else
 711                        echo "# Submodule changes to be committed:"
 712                fi
 713                echo "#"
 714                sed -e 's|^|# |' -e 's|^# $|#|'
 715        else
 716                cat
 717        fi
 718}
 719#
 720# List all submodules, prefixed with:
 721#  - submodule not initialized
 722#  + different revision checked out
 723#
 724# If --cached was specified the revision in the index will be printed
 725# instead of the currently checked out revision.
 726#
 727# $@ = requested paths (default to all)
 728#
 729cmd_status()
 730{
 731        # parse $args after "submodule ... status".
 732        orig_flags=
 733        while test $# -ne 0
 734        do
 735                case "$1" in
 736                -q|--quiet)
 737                        GIT_QUIET=1
 738                        ;;
 739                --cached)
 740                        cached=1
 741                        ;;
 742                --recursive)
 743                        recursive=1
 744                        ;;
 745                --)
 746                        shift
 747                        break
 748                        ;;
 749                -*)
 750                        usage
 751                        ;;
 752                *)
 753                        break
 754                        ;;
 755                esac
 756                orig_flags="$orig_flags $(git rev-parse --sq-quote "$1")"
 757                shift
 758        done
 759
 760        module_list "$@" |
 761        while read mode sha1 stage path
 762        do
 763                name=$(module_name "$path") || exit
 764                url=$(git config submodule."$name".url)
 765                displaypath="$prefix$path"
 766                if test -z "$url" || ! test -d "$path"/.git -o -f "$path"/.git
 767                then
 768                        say "-$sha1 $displaypath"
 769                        continue;
 770                fi
 771                set_name_rev "$path" "$sha1"
 772                if git diff-files --ignore-submodules=dirty --quiet -- "$path"
 773                then
 774                        say " $sha1 $displaypath$revname"
 775                else
 776                        if test -z "$cached"
 777                        then
 778                                sha1=$(clear_local_git_env; cd "$path" && git rev-parse --verify HEAD)
 779                                set_name_rev "$path" "$sha1"
 780                        fi
 781                        say "+$sha1 $displaypath$revname"
 782                fi
 783
 784                if test -n "$recursive"
 785                then
 786                        (
 787                                prefix="$displaypath/"
 788                                clear_local_git_env
 789                                cd "$path" &&
 790                                eval cmd_status "$orig_args"
 791                        ) ||
 792                        die "Failed to recurse into submodule path '$path'"
 793                fi
 794        done
 795}
 796#
 797# Sync remote urls for submodules
 798# This makes the value for remote.$remote.url match the value
 799# specified in .gitmodules.
 800#
 801cmd_sync()
 802{
 803        while test $# -ne 0
 804        do
 805                case "$1" in
 806                -q|--quiet)
 807                        GIT_QUIET=1
 808                        shift
 809                        ;;
 810                --)
 811                        shift
 812                        break
 813                        ;;
 814                -*)
 815                        usage
 816                        ;;
 817                *)
 818                        break
 819                        ;;
 820                esac
 821        done
 822        cd_to_toplevel
 823        module_list "$@" |
 824        while read mode sha1 stage path
 825        do
 826                name=$(module_name "$path")
 827                url=$(git config -f .gitmodules --get submodule."$name".url)
 828
 829                # Possibly a url relative to parent
 830                case "$url" in
 831                ./*|../*)
 832                        url=$(resolve_relative_url "$url") || exit
 833                        ;;
 834                esac
 835
 836                say "Synchronizing submodule url for '$name'"
 837                git config submodule."$name".url "$url"
 838
 839                if test -e "$path"/.git
 840                then
 841                (
 842                        clear_local_git_env
 843                        cd "$path"
 844                        remote=$(get_default_remote)
 845                        git config remote."$remote".url "$url"
 846                )
 847                fi
 848        done
 849}
 850
 851# This loop parses the command line arguments to find the
 852# subcommand name to dispatch.  Parsing of the subcommand specific
 853# options are primarily done by the subcommand implementations.
 854# Subcommand specific options such as --branch and --cached are
 855# parsed here as well, for backward compatibility.
 856
 857while test $# != 0 && test -z "$command"
 858do
 859        case "$1" in
 860        add | foreach | init | update | status | summary | sync)
 861                command=$1
 862                ;;
 863        -q|--quiet)
 864                GIT_QUIET=1
 865                ;;
 866        -b|--branch)
 867                case "$2" in
 868                '')
 869                        usage
 870                        ;;
 871                esac
 872                branch="$2"; shift
 873                ;;
 874        --cached)
 875                cached="$1"
 876                ;;
 877        --)
 878                break
 879                ;;
 880        -*)
 881                usage
 882                ;;
 883        *)
 884                break
 885                ;;
 886        esac
 887        shift
 888done
 889
 890# No command word defaults to "status"
 891test -n "$command" || command=status
 892
 893# "-b branch" is accepted only by "add"
 894if test -n "$branch" && test "$command" != add
 895then
 896        usage
 897fi
 898
 899# "--cached" is accepted only by "status" and "summary"
 900if test -n "$cached" && test "$command" != status -a "$command" != summary
 901then
 902        usage
 903fi
 904
 905"cmd_$command" "$@"